Open CASCADE Technology: BOPAlgo_BOP Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions | Protected Attributes
BOPAlgo_BOP Class Reference

`#include <BOPAlgo_BOP.hxx>`

Inheritance diagram for BOPAlgo_BOP:
[legend]

## Public Member Functions
| BOPAlgo_BOP ()
| Empty constructor. More...
virtual | ~BOPAlgo_BOP ()
| BOPAlgo_BOP (const BOPCol_BaseAllocator &theAllocator)
virtual void | Clear ()
| Clears internal fields and arguments. More...
virtual void | AddTool (const TopoDS_Shape &theShape)
| Adds Tool argument of the operation. More...
virtual void | SetTools (const TopTools_ListOfShape &theShapes)
virtual void | SetTools (const BOPCol_ListOfShape &theShapes)
void | SetOperation (const BOPAlgo_Operation theOperation)
BOPAlgo_Operation | Operation () const
virtual void | Perform ()
Public Member Functions inherited from BOPAlgo_Builder
| BOPAlgo_Builder ()
virtual | ~BOPAlgo_Builder ()
| BOPAlgo_Builder (const BOPCol_BaseAllocator &theAllocator)
BOPAlgo_PPaveFiller | PPaveFiller ()
BOPDS_PDS | PDS ()
virtual void | AddArgument (const TopoDS_Shape &theShape)
void | SetArguments (const TopTools_ListOfShape &theLS)
virtual void | SetArguments (const BOPCol_ListOfShape &theLS)
const BOPCol_ListOfShape & | Arguments () const
virtual void | PerformWithFiller (const BOPAlgo_PaveFiller &theFiller)
virtual const TopTools_ListOfShape & | Generated (const TopoDS_Shape &theS)
| Returns the list of shapes generated from the shape theS. More...
virtual const TopTools_ListOfShape & | Modified (const TopoDS_Shape &theS)
| Returns the list of shapes modified from the shape theS. More...
virtual Standard_Boolean | IsDeleted (const TopoDS_Shape &theS)
| Returns true if the shape theS has been deleted. More...
const BOPCol_DataMapOfShapeListOfShape & | Images () const
Standard_Boolean | IsInterferred (const TopoDS_Shape &theS) const
const BOPCol_DataMapOfShapeShape & | Origins () const
| Returns myOrigins. More...
const BOPCol_DataMapOfShapeShape & | ShapesSD () const
| Returns myShapesSD. More...
const BOPCol_DataMapOfShapeListOfShape & | Splits () const
| Returns mySplits. More...
void | SetFuzzyValue (const Standard_Real theFuzz)
| Sets the additional tolerance. More...
Standard_Real | FuzzyValue () const
| Returns the additional tolerance. More...
Public Member Functions inherited from BOPAlgo_BuilderShape
const TopoDS_Shape & | Shape () const
| Returns the result of algorithm. More...
Standard_Boolean | HasDeleted () const
| Returns true if the at least one shape(or subshape) of arguments has been deleted. More...
Standard_Boolean | HasGenerated () const
| Returns true if the at least one shape(or subshape) of arguments has generated shapes. More...
Standard_Boolean | HasModified () const
| Returns true if the at least one shape(or subshape) of arguments has modified shapes. More...
const BOPCol_IndexedDataMapOfShapeListOfShape & | ImagesResult () const
Public Member Functions inherited from BOPAlgo_Algo
Standard_Integer | ErrorStatus () const
Standard_Integer | WarningStatus () const
const BOPCol_BaseAllocator & | Allocator () const
void | SetRunParallel (const Standard_Boolean theFlag)
| Set the flag of parallel processing if <theFlag> is true the parallel processing is switched on if <theFlag> is false the parallel processing is switched off. More...
Standard_Boolean | RunParallel () const
| Returns the flag of parallel processing. More...
void | SetProgressIndicator (const Handle< Message_ProgressIndicator > &theObj)
| Set the Progress Indicator object. More...

## Protected Member Functions
virtual void | CheckData ()
virtual void | Prepare ()
| Provides preparing actions. More...
virtual void | PerformInternal1 (const BOPAlgo_PaveFiller &thePF)
| Performs calculations using prepared Filler object <thePF> More...
virtual void | BuildResult (const TopAbs_ShapeEnum theType)
void | BuildShape ()
void | BuildRC ()
void | BuildSolid ()
Standard_Boolean | IsBoundSplits (const TopoDS_Shape &theS, BOPCol_IndexedDataMapOfShapeListOfShape &theMEF)
Protected Member Functions inherited from BOPAlgo_Builder
virtual void | PrepareHistory ()
| Prepare information for history support. More...
virtual void | PerformInternal (const BOPAlgo_PaveFiller &thePF)
void | FillImagesVertices ()
void | FillImagesEdges ()
void | FillImagesContainers (const TopAbs_ShapeEnum theType)
void | FillImagesCompounds ()
void | FillImagesContainer (const TopoDS_Shape &theS, const TopAbs_ShapeEnum theType)
void | FillImagesCompound (const TopoDS_Shape &theS, BOPCol_MapOfShape &theMF)
void | FillImagesFaces ()
virtual void | BuildSplitFaces ()
void | FillSameDomainFaces ()
void | FillImagesFaces1 ()
void | FillImagesSolids ()
void | BuildDraftSolid (const TopoDS_Shape &theSolid, TopoDS_Shape &theDraftSolid, BOPCol_ListOfShape &theLIF)
virtual void | FillIn3DParts (BOPCol_DataMapOfShapeListOfShape &theInParts, BOPCol_DataMapOfShapeShape &theDraftSolids, const BOPCol_BaseAllocator &theAllocator)
void | BuildSplitSolids (BOPCol_DataMapOfShapeListOfShape &theInParts, BOPCol_DataMapOfShapeShape &theDraftSolids, const BOPCol_BaseAllocator &theAllocator)
void | FillInternalShapes ()
virtual void | PostTreat ()
Protected Member Functions inherited from BOPAlgo_BuilderShape
| BOPAlgo_BuilderShape ()
virtual | ~BOPAlgo_BuilderShape ()
| BOPAlgo_BuilderShape (const BOPCol_BaseAllocator &theAllocator)
Protected Member Functions inherited from BOPAlgo_Algo
| BOPAlgo_Algo ()
virtual | ~BOPAlgo_Algo ()
| BOPAlgo_Algo (const BOPCol_BaseAllocator &theAllocator)
virtual void | CheckResult ()
void | UserBreak () const
| Breaks the execution if the break signal is indicated by myProgressIndicator. More...

## Protected Attributes
BOPAlgo_Operation | myOperation
Standard_Integer | myDims [2]
TopoDS_Shape | myRC
BOPCol_ListOfShape | myTools
BOPCol_MapOfShape | myMapTools
Protected Attributes inherited from BOPAlgo_Builder
BOPCol_ListOfShape | myArguments
BOPCol_MapOfShape | myMapFence
BOPAlgo_PPaveFiller | myPaveFiller
BOPDS_PDS | myDS
Handle< IntTools_Context > | myContext
Standard_Integer | myEntryPoint
BOPCol_DataMapOfShapeListOfShape | myImages
BOPCol_DataMapOfShapeShape | myShapesSD
BOPCol_DataMapOfShapeListOfShape | mySplits
BOPCol_DataMapOfShapeShape | myOrigins
Standard_Real | myFuzzyValue
Protected Attributes inherited from BOPAlgo_BuilderShape
TopoDS_Shape | myShape
TopTools_ListOfShape | myHistShapes
BOPCol_MapOfShape | myMapShape
Standard_Boolean | myHasDeleted
Standard_Boolean | myHasGenerated
Standard_Boolean | myHasModified
BOPCol_IndexedDataMapOfShapeListOfShape | myImagesResult
Standard_Boolean | myFlagHistory
Protected Attributes inherited from BOPAlgo_Algo
BOPCol_BaseAllocator | myAllocator
Standard_Integer | myErrorStatus
Standard_Integer | myWarningStatus
Standard_Boolean | myRunParallel
Handle< Message_ProgressIndicator > | myProgressIndicator

## Additional Inherited Members
Static Public Member Functions inherited from BOPAlgo_Algo
static Standard_Boolean | GetParallelMode ()
static void | SetParallelMode (const Standard_Boolean theNewMode)

## Constructor & Destructor Documentation

BOPAlgo_BOP::BOPAlgo_BOP | ( |  | ) |

Empty constructor.

virtual BOPAlgo_BOP::~BOPAlgo_BOP | ( |  | ) |
| virtual

BOPAlgo_BOP::BOPAlgo_BOP | ( | const BOPCol_BaseAllocator & | theAllocator | ) |

## Member Function Documentation

virtual void BOPAlgo_BOP::AddTool | ( | const TopoDS_Shape & | theShape | ) |
| virtual

Adds Tool argument of the operation.

void BOPAlgo_BOP::BuildRC | ( |  | ) |
| protected

virtual void BOPAlgo_BOP::BuildResult | ( | const TopAbs_ShapeEnum | theType | ) |
| protectedvirtual

Reimplemented from BOPAlgo_Builder.

void BOPAlgo_BOP::BuildShape | ( |  | ) |
| protected

void BOPAlgo_BOP::BuildSolid | ( |  | ) |
| protected

virtual void BOPAlgo_BOP::CheckData | ( |  | ) |
| protectedvirtual

Reimplemented from BOPAlgo_Builder.

virtual void BOPAlgo_BOP::Clear | ( |  | ) |
| virtual

Clears internal fields and arguments.

Reimplemented from BOPAlgo_Builder.

Reimplemented in BRepFeat_Builder.

Standard_Boolean BOPAlgo_BOP::IsBoundSplits | ( | const TopoDS_Shape & | theS,
|  | BOPCol_IndexedDataMapOfShapeListOfShape & | theMEF
| ) |  |
| protected

BOPAlgo_Operation BOPAlgo_BOP::Operation | ( |  | ) | const

virtual void BOPAlgo_BOP::Perform | ( |  | ) |
| virtual

Reimplemented from BOPAlgo_Builder.

virtual void BOPAlgo_BOP::PerformInternal1 | ( | const BOPAlgo_PaveFiller & | thePF | ) |
| protectedvirtual

Performs calculations using prepared Filler object <thePF>

Reimplemented from BOPAlgo_Builder.

virtual void BOPAlgo_BOP::Prepare | ( |  | ) |
| protectedvirtual

Provides preparing actions.

Reimplemented from BOPAlgo_Builder.

Reimplemented in BRepFeat_Builder.

void BOPAlgo_BOP::SetOperation | ( | const BOPAlgo_Operation | theOperation | ) |

virtual void BOPAlgo_BOP::SetTools | ( | const TopTools_ListOfShape & | theShapes | ) |
| virtual

virtual void BOPAlgo_BOP::SetTools | ( | const BOPCol_ListOfShape & | theShapes | ) |
| virtual

## Field Documentation

Standard_Integer BOPAlgo_BOP::myDims[2]
| protected

BOPCol_MapOfShape BOPAlgo_BOP::myMapTools
| protected

BOPAlgo_Operation BOPAlgo_BOP::myOperation
| protected

TopoDS_Shape BOPAlgo_BOP::myRC
| protected

BOPCol_ListOfShape BOPAlgo_BOP::myTools
| protected

The documentation for this class was generated from the following file:

- BOPAlgo_BOP.hxx